##parameters=REQUEST
# $Id: display_session_results.py 1175 2007-01-02 11:37:44Z joachim $
"""
process the Application Form
return html renderer + psm
"""
import DateTime
current = DateTime.DateTime()
pr = context.portal_registration

validate = REQUEST.has_key("cpsdocument_create_button")

lt = context.portal_layouts
#pr = context.portal_registration

res,psm,ds = lt.renderLayout(layout_id= 'student_session_results_search',
                      schema_id= 'student_returning',
                      context=context,
                      mapping=validate and REQUEST,
                      ob={},
                      layout_mode='create',
                      formaction = "display_session_results",
                      button = "Search",
                      commit=False,
                      )
if psm == 'invalid':
    return context.display_session_results_form(rendered = res,
                                 psm = "Please correct your input!",
                                 #psm = "%s, %s" % (psm,ds),
                                 firstlayout = True,
                                 lastlayout = True,
                                 ds = ds,
                                 )
elif psm == '':
    return context.display_session_results_form(rendered = res,
                                 psm = None,
                                 firstlayout = True,
                                 lastlayout = True,
                                 ds = ds,
                                 )
elif psm == 'valid':
    pass
brains = ds.get('results')
sem1 = []
sem2 = []
with_courses_cat = hasattr(context,'courses_catalog')
fields = context.results_import.schema()
for r in brains:
    result = {}
    for field in fields:
        result[field] = getattr(r,field)
    if with_courses_cat:
        res = context.courses_catalog(code = r.CosCode)
    if with_courses_cat and res:
        result['title'] = res[0].title
    else:
        result['title'] = "To Be Determined"
    if r.Semester == '2':
        sem2.append(result)
    else:
        sem1.append(result)
#from Products.zdb import set_trace;set_trace()
results = (sem1, sem2)
registered = None
student_rec = ds.get('student')
res = context.students_catalog(matric_no = student_rec.matric_no)
if res:
    student_id = res[0].id
    student_obj = getattr(context.portal_url.getPortalObject().campus.students,student_id,None)
    if student_obj and hasattr(student_obj,'application'):
        registered = student_id
    
return context.session_results_anon_view(student=student_rec,
                                           results=results,
                                           registered = registered)

